package com.supervision.knowsub.service.impl;

import cn.hutool.core.util.ObjectUtil;
import cn.hutool.core.util.StrUtil;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.supervision.knowsub.service.KnowledgeManageService;
import com.supervision.knowsub.model.Knowledge;
import com.supervision.knowsub.service.KnowledgeService;
import lombok.RequiredArgsConstructor;
import lombok.extern.slf4j.Slf4j;
import org.springframework.stereotype.Service;

@Slf4j
@Service
@RequiredArgsConstructor
public class KnowledgeManageServiceImpl implements KnowledgeManageService {

    private final KnowledgeService knowledgeService;


    @Override
    public IPage<Knowledge> queryKnowledgePage(Integer status, String title, String publishDeptName, Integer pageNum, Integer pageSize) {
        return knowledgeService.lambdaQuery().eq(ObjectUtil.isNotEmpty(status), Knowledge::getStatus, status)
                .like(StrUtil.isNotBlank(title), Knowledge::getTitle, title)
                .like(StrUtil.isNotBlank(publishDeptName), Knowledge::getPublishDept, publishDeptName)
                .page(new Page<>(pageNum, pageSize));
    }
}
